/*
 *      obj.c
 *      C "objektorientiert"
 *      Die C-"Klasse" string
 *      
 */
 
#include <stdio.h>
#include <string.h>

#define SLEN 256        /* Max. Stringlaenge    */

struct string {         /* Die "Klasse" String  */
  char s[SLEN];         /*   Stringpuffer       */
  int l;                /*   Stringlaenge       */
  void (*put)();        /*   String setzen      */
  char *(*get)();       /*   String holen       */
  int (*len)();         /*   Stringlaenge holen */
};

struct string *init(char *);

void main(void)
{
  char buf[256];
  struct string *s1, *s2;
  
  s1 = init("");
  s2 = init("hallo");  
  
  printf("s1: %s %d\n", (*s1->get)(s1), (*s1->len)(s1));
  printf("s2: %s %d\n", (*s2->get)(s2), (*s2->len)(s2));
  
  printf("String fuer s1: ");
  gets(buf);
  (*s1->put)(s1, buf);
  printf("s1: %s %d\n", (*s1->get)(s1), (*s1->len)(s1));

} /* main() */

/* Interne Routinen fuer die "Klasse" string */

/* Stringlaenge geben */
static int _len(struct string *s)
{
  if (s)
    return(s->l);
  
} /* _len() */

/* String geben */
static char *_get(struct string *s)
{
  if (s)
    return(s->s);
    
} /* _get() */

/* String setzen */
static void _put(struct string *s, char *cs)
{
  if(s && cs) {
    strcpy(s->s, cs);
    s->l = strlen(s->s);
  }

} /* _put() */

/* Initialisierungsroutine fuer "Objekt" der "Klasse" string */

struct string *init(char *cs)
{
  struct string *s;
  
  s = (struct string *) calloc(1, sizeof(struct string));
  if (s) {  
    strcpy(s->s, cs);
    s->l = strlen(s->s);
    s->put  = _put;
    s->get  = _get;
    s->len  = _len;
  }
  return(s);
    
} /* init() */
